import 'package:mmoo_base/entity/level_sysy_show_im_entity.dart';
import 'package:mmoo_base/entity/user_sys_achieve_entity.dart';
import 'package:mmoo_base/entity/user_sys_show_badge_im_entity.dart';
import 'package:mmoo_live_room/Model/model_live_user_list_entity.dart';
import 'package:mmoo_live_room/generated/json/base/json_convert_content.dart';

class ModelRtmMessage {
  String? typeMethod; //函数名称
  String? userId; //userid
  String? name; //用户昵称
  String? headImage; //用户头像
  String? roomUserId; //用户房间id
  String? content;
  String? roomId;
  String? isHost;
  String? msgId;
  String? translatorText;
  ModelLiveIncomeState? incomeState;
  ModelLiveHeadFrame? headFrame;
  // List<ModelLiveUserListAchieves>? achieves;
  LevelSysyShowImEntity? level;
  List<UserSysShowBadgeImEntity>? achieves;
  // UserSysShowBadgeImEntity?  badge;

  ModelRtmMessage(
      {this.userId,
      this.name,
      this.msgId,
      this.content,
      this.headImage,
      this.roomUserId,
      this.isHost,
      this.translatorText,
      this.roomId,
      this.achieves,
      this.level,
      this.typeMethod});

  ModelRtmMessage.fromJson(Map<String, dynamic> json) {
    typeMethod = json['typeMethod'].toString();
    userId = json['userId'].toString();
    name = json['name'].toString();
    content = json['content'].toString();
    headImage = json['headImage'].toString();
    isHost = json['isHost'].toString();
    roomId = json['roomId'].toString();
    msgId = json['msgId'];
    translatorText = json['translatorText'];
    roomUserId = json['roomUserId'].toString();
    // final List<UserSysShowBadgeImEntity>? achievesModel = jsonConvert
    //     .convertListNotNull<UserSysShowBadgeImEntity>(json['achieves']);
    if (json['achieves'] != null) {
      achieves = (json['achieves'] as List)
          .map((e) => UserSysShowBadgeImEntity.fromJson(e))
          .toList();
    }
    // if (achievesModel != null) {
    //   achieves = achievesModel;
    // }
    if (json['incomeState'] != null) {
      incomeState = ModelLiveIncomeState.fromJson(json['incomeState']);
    }
    if (json['headFrame'] != null) {
      headFrame = ModelLiveHeadFrame.fromJson(json['headFrame']);
    }
    // if (json['badge'] != null) {
    //   badge = UserSysShowBadgeImEntity.fromJson(json['badge']);
    // }
    if (json['level'] != null) {
      level = LevelSysyShowImEntity.fromJson(json['level']);
    }

    // ModelLiveIncomeState? incomeState;
    // ModelLiveHeadFrame? headFrame;
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data['typeMethod'] = this.typeMethod;
    data['userId'] = this.userId;
    data['name'] = this.name;
    data['headImage'] = this.headImage;
    data['roomUserId'] = this.roomUserId;
    data['isHost'] = this.isHost;
    data['roomId'] = this.roomId;
    data['content'] = this.content;
    data['msgId'] = this.msgId;
    data['translatorText'] = this.translatorText;
    // data['level'] = this.level.toString()
    return data;
  }
}
